unit funktionen;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Graphics,math;

type
  TMAI = array of Integer;
  Kartenbilder = array[1..36] of TBitmap;

  function inArray(iArr:TMAI;iFind:integer):boolean;
  function DeleteArrayElement(arr: TMAI;index: integer): TMAI;
  function AddArrayElement(arr: TMAI; const zahl: Integer):TMAI;
  function KartenListeHinzufuegen(arr:TMAI): Boolean;
  function KartenFarbe(nr:Integer): String;
  function KartenWert(nr:Integer): String;
  function ArrayToString(arr:TMAI):String;
  
implementation

   function inArray(iArr:TMAI;iFind:integer):boolean;
var i: Integer;
begin
    if length(iArr) = 0 then
    begin
        Result := false;
    end else begin
    Result := False;
    for i:= 0 to length(iArr) do
    begin
       if iArr[i] = iFind then
       begin
           Result := True;
       end;
    end;
    end;
end;

function DeleteArrayElement(arr: TMAI;index: integer): TMAI;
var i: integer;
begin
  for i := 0 to high(arr) do
  begin
      if arr[i] = index then
      begin
          arr[i] := -1;
          Break;
      end;
  end;
  // Lnge krzen (bei dyn. Arrays)
  Result := arr;
end;

function AddArrayElement(arr: TMAI; const zahl: Integer):TMAI;
begin
   SetLength(arr, high(arr) + 2);
   arr[high(arr)]:= zahl;
   Result:=arr;
end;

function KartenListeHinzufuegen(arr:TMAI): Boolean;
begin

end;

function KartenFarbe(nr:Integer): String;
var
   zahl: Integer;
begin
   zahl := ceil( nr / 36 * 4 );
   case zahl of
   1: Result:= 'Herz';
   2: Result:= 'Karo';
   3: Result:= 'Pik';
   4: Result:= 'Kreuz';
   end;
end;

function KartenWert(nr:Integer): String;
var
   zahl: Integer;
begin
   zahl := nr mod 9;
   case zahl of
   1: Result:= '6';
   2: Result:= '7';
   3: Result:= '8';
   4: Result:= '9';
   5: Result:= '10';
   6: Result:= 'Bube';
   7: Result:= 'Dame';
   8: Result:= 'Knig';
   0: Result:= 'Ass';
   end;
end;

function ArrayToString(arr:TMAI):String;
var
   i: Integer;
   txt: String;
begin
   txt := '';
   for i := 0 to length(arr) do
   begin
      txt := txt + inttostr(arr[i]) + #13;
   end;
   Result:=txt;
end;

end.

